module BusinessFlow
  # Exception raised by DSL when flow execution fails
  class FlowFailedException < RuntimeError
    attr_reader :flow

    def initialize(flow)
      errors = flow.errors.full_messages.join(', ')
      super("Failed execution of #{flow.class.name}: #{errors}")
      @flow = flow
    end
  end
end
